/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;

//
_obmTypesMappings = [];
_obmTypesMappings["CELL;VOICE;X-OBM-Ref1"] = "mobilePhone";
_obmTypesMappings["PAGER;X-OBM-Ref1"] = "pagerPhone";
_obmTypesMappings["WORK;VOICE;X-OBM-Ref1"] = "workPhone";
_obmTypesMappings["WORK;FAX;X-OBM-Ref1"] = "workFax";
_obmTypesMappings["HOME;VOICE;X-OBM-Ref1"] = "homePhone";
_obmTypesMappings["INTERNET;X-OBM-Ref1"] = "email";
_obmTypesMappings["INTERNET;X-OBM-Ref2"] = "email2";
_obmTypesMappings["URL;X-OBM-Ref1"] = "workWebPage";
_obmTypesMappings["URL;X-OBM-Ref2"] = "homeWebPage";
_obmTypesMappings["HOME;X-OBM-Ref1"] = "home";
_obmTypesMappings["WORK;X-OBM-Ref1"] = "work";

//
_contactTypesMappings = [];
_contactTypesMappings["mobilePhone"] = "CELL;VOICE;X-OBM-Ref1";
_contactTypesMappings["pagerPhone"] = "PAGER;X-OBM-Ref1";
_contactTypesMappings["workPhone"] = "WORK;VOICE;X-OBM-Ref1";
_contactTypesMappings["workFax"] = "WORK;FAX;X-OBM-Ref1";
_contactTypesMappings["homePhone"] = "HOME;VOICE;X-OBM-Ref1";
_contactTypesMappings["email"] = "INTERNET;X-OBM-Ref1";
_contactTypesMappings["email2"] = "INTERNET;X-OBM-Ref2";
_contactTypesMappings["workWebPage"] = "URL;X-OBM-Ref1";
_contactTypesMappings["homeWebPage"] = "URL;X-OBM-Ref2";
_contactTypesMappings["home"] = "HOME;X-OBM-Ref1";
_contactTypesMappings["work"] = "WORK;X-OBM-Ref1";

// TODO extract super class
function _appendXMLElement(aRootElement, aChildElementName, aChildElementValue) {
	if ( aChildElementValue === undefined || aChildElementValue === null ) {
	  //append nothing
	} else {
	  aRootElement[aChildElementName] = aChildElementValue;
	}
}

function _xS(value) {
	// FIXME : toString() ?
	return (value.length() == 1) ? value + "" : "";
}

function _xL(value, def) {
	if (value.length() == 1)
		return parseInt(value + "", 10);
	if (def)
		return def;
	return 0;
}

function _xD(value) {
	return (value.length() == 1) ? parseFloat(value + "") : 0;
}

function _xB(value) {
	return value + "" == "true";
}

function _sF(value) {
	return (value ? value : null);
}

function _sX(value) {
	return (value ? value : "");
}

function JSObjContactShell(aContact /* obmIRContact */) {
	var obj = <contact/>;// xmlns="http://www.obm.org/xsd/sync/contact.xsd"/>;
	if (aContact.uid != null) {
		obj.@uid = aContact.uid;
	}
	
	_appendXMLElement(obj, "first", aContact.firstName);
	_appendXMLElement(obj, "last", aContact.lastName);
	_appendXMLElement(obj, "aka", aContact.aka);
	_appendXMLElement(obj, "title", aContact.title);
	_appendXMLElement(obj, "service", aContact.service);
	_appendXMLElement(obj, "company", aContact.company);
	// FIXME is read-only ?
	_appendXMLElement(obj, "comment", aContact.comment);
	
	// emails
	obj.emails = <emails/>;
	if (aContact.email)
		obj.emails.mail += <mail label={_contactTypesMappings["email"]} value={aContact.email}/>;
	if (aContact.email2)
		obj.emails.mail += <mail label={_contactTypesMappings["email2"]} value={aContact.email2}/>;
		
	// phones
	obj.phones = <phones/>;
	if (aContact.workPhone)
		obj.phones.phone += <phone label={_contactTypesMappings["workPhone"]} number={aContact.workPhone}/>;
	if (aContact.homePhone)
		obj.phones.phone += <phone label={_contactTypesMappings["homePhone"]} number={aContact.homePhone}/>;
	if (aContact.workFax)
		obj.phones.phone += <phone label={_contactTypesMappings["workFax"]} number={aContact.workFax}/>;
	if (aContact.pagerPhone)
		obj.phones.phone += <phone label={_contactTypesMappings["pagerPhone"]} number={aContact.pagerPhone}/>;
	if (aContact.mobilePhone)
		obj.phones.phone += <phone label={_contactTypesMappings["mobilePhone"]} number={aContact.mobilePhone}/>;
		
	// home and word addresses
	obj.addresses = <addresses/>;
	dump("addr:" + aContact.homeStreet +"\n");
	dump("addr:" + aContact.homeCountry +"\n");
	dump("addr:" + aContact.homeCity +"\n");
	dump("addr:" + aContact.homeState +"\n");
	dump("addr:" + aContact.homeZipCode +"\n");
	if (aContact.homeStreet || aContact.homeCountry || aContact.homeCity || aContact.homeState || aContact.homeZipCode) {
		var home = <address label={_contactTypesMappings["home"]}>{_sX(aContact.homeStreet)}</address>;
		home.@country = _sX(aContact.homeCountry);
		home.@town = _sX(aContact.homeCity)
		home.@state = _sX(aContact.homeState);
		home.@zip = _sX(aContact.homeZipCode);
		//home.@expressPostal = _sX(aContact.homeExpressPostal);
		obj.addresses.address += home;
	}
	
	if (aContact.workStreet || aContact.workCountry || aContact.workCity || aContact.workState || aContact.workZipCode) {
		var work = <address label={_contactTypesMappings["work"]}>{_sX(aContact.workStreet)}</address>;
		work.@country = _sX(aContact.workCountry);
		work.@town = _sX(aContact.workCity);
		work.@state = _sX(aContact.workState);
		work.@zip = _sX(aContact.workZipCode);
		//work.@expressPostal = _sX(aContact.workExpressPostal);
		obj.addresses.address += work;
	}
	
	// websites
	obj.websites = <websites/>;
	if (aContact.homeWebPage)
		obj.websites.site += <site label={_contactTypesMappings["homeWebPage"]} url={aContact.homeWebPage}/>;
	if (aContact.workWebPage)
		obj.websites.site += <site label={_contactTypesMappings["workWebPage"]} url={aContact.workWebPage}/>;
	
	obj.instantmessaging = <instantmessaging/>;
	
	if (aContact.caluri)
		obj.caluri = <caluri>{_sX(aContact.caluri)}</caluri>;
	
	return ("<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + obj.toString());
}

function getBookName(aBook) {
	//crappy !!!
	if (aBook == 0)
		return "users";
	return "contacts";
}

function ObmRAddressBookProxy() {
  //Init logger
  this.logger = Cc["@obm.org/calendar/logger;1"].createInstance(Ci.obmILogger);
  var writer = Cc["@obm.org/calendar/writer;1?type=unixfile"].getService(Ci.obmILoggerWriter);
  this.logger.setLevelWriter(this.logger.LOAD_LEVEL, writer);
  this.logger.setHeader("obmAddressBookProxy: ");
  this.logger.debug("new obmAddressBookProxy()", false, false);

	this.RESTClient = Cc["@obm.org/restclient;1"].getService().wrappedJSObject;

	this._listeners = [];
	this._url = null;
	this._token = {
		session_id: null
	};
};

ObmRAddressBookProxy.prototype = {
	QueryInterface: function(aIID) {
		if (!aIID.equals(Ci.nsISupports) &&
			!aIID.equals(Ci.obmIRAddressBookProxy) &&
			!aIID.equals(Ci.obmIRProxyBase)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},

	/*
	 * obmIRProxyBase
	 */
	get token() {
		return this._token;
	},
	set token(aToken) {
		this._token = aToken;
	},

	get PortUrl() {
		return this._url;
	},
	set PortUrl(aURL) {
		if(aURL.charAt(aURL.length -1) == '/') {
		  aURL = aURL.substring(0, aURL.length - 1);
		}
		this._url = aURL + "/book";
		this._loginUrl = aURL + "/login";
	},


	addListener: function(listener) {
		for (var i = 0; i < this._listeners.length; ++i) {
			if (this._listeners[i] == listener)
				return;
		}
		this._listeners.push(listener);
	},

	removeListener: function(listener) {
		this._listeners = [];
	},
	_notifyListeners: function(aResultCode, aMethodName, aObj, aData) {
		// A copy is needed, a new listeners could has been added during the callbacks
		var listeners = this._listeners.slice(0, this._listeners.length);
		for (var i = 0; i < listeners.length; ++i) {
			try {
				//timer.(function() {
				listeners[i].onResponse(aResultCode, aMethodName, aObj, aData);
				//}, 1, timer.TYPE_ONE_SHOT);
			} catch(e) {
				//Continue to notify listeners
        this.logger.error(e + " (ignored)");
			}
		}
	},




	/*
	 * obmIRAddressBookProxy
	 */
	_callback: function(aMethodName, aObj, aXml, aData) {
    this.logger.debug("_callback(aMethodName = " + aMethodName + ")", false, false);
		if (aObj && aObj.name == "Error") {
			var msg = Cc["@mozilla.org/supports-string;1"].createInstance(Ci.nsISupportsString);
			
			if (aMethodName == "doLogin" &&  aObj.fileName != "Connection failure") {
				msg.data = "No token available";
			} else {
				msg.data = aObj.fileName;
			}
      this._notifyListeners(Cr.NS_ERROR_FAILURE, aMethodName, msg, aData);
      return;
		}
		switch(aMethodName) {
			case "doLogin":
			var sid = _xS(aXml.*::sid);
			this._token.session_id = sid;
			this.logger.debug("token obtained with sid:"+sid, false, false);
			this._notifyListeners(Cr.NS_OK, aMethodName, null, aData);
		break;
			case "getSync":
				this._notifyListeners(Cr.NS_OK, aMethodName, new GetSyncContactResponseShell(aXml), aData);
				break;
			case "getAddressBookSync":
				this._notifyListeners(Cr.NS_OK, aMethodName, new AddressBookChangesResponseShell(aXml), aData);
				break;
			case "getContactFromId":
			case "createContact":
			case "createContactInBook":
			case "createContactWithoutDuplicate":
			case "modifyContact":
			case "removeContact":
				this._notifyListeners(Cr.NS_OK, aMethodName, new ContactShell(aXml), aData);
				break;
			case "unsubscribeBook":
				/* TODO: handle boolean return */
				this._notifyListeners(Cr.NS_OK, aMethodName, null, aData);
				break;
			default:
			this._notifyListeners(Cr.NS_ERROR_FAILURE, aMethodName, null, aData);
		};
	},

	getSync: function(aBook, aLastSync, aData) {
    this.logger.debug("getSync()", false, false);
		var p = this.RESTClient.newRESTClientParameters();
		p.add("sid", this._token.session_id);
		p.add("book", getBookName(aBook));
		p.add("lastSync", aLastSync);
		// closure
		var self = this;
		this.RESTClient.invoke(this._url, "getSync", p, true, function(name, obj, xml, data) {self._callback(name, obj, xml, data);}, aData);
	},
	getAddressBookSync: function(aLastSync, aData) {
		this.logger.debug("getAddressBookSync", false, false);
		var p = this.RESTClient.newRESTClientParameters();
		p.add("sid", this._token.session_id);
		p.add("lastSync", aLastSync);
		// closure
		var self = this;
		this.RESTClient.invoke(this._url, "getAddressBookSync", p, true, function(name, obj, xml, data) {self._callback(name, obj, xml, data);}, aData);
	},
	_createContactInternal: function(aBook, aContact, aUniq, aData) {
		var p = this.RESTClient.newRESTClientParameters();
		p.add("sid", this._token.session_id);
		p.add("book", getBookName(aBook));
		p.add("contact", JSObjContactShell(aContact));
		// closure
		var self = this;
		this.RESTClient.invoke(this._url, aUniq ? "createContactWithoutDuplicate" : "createContact", p, true, function(name, obj, xml, data) {self._callback(name, obj, xml, data);}, aData);
	},
	createContact: function(aBook, aContact, aData) {
    this.logger.debug("createContact()", false, false);
		return this._createContactInternal(aBook, aContact, false, aData);
	},
	createContactWithoutDuplicate: function(aBook, aContact, aData) {
    this.logger.debug("createContactWithoutDuplicate()", false, false);
		return this._createContactInternal(aBook, aContact, true, aData);
	},
	createContactInBook: function(aBookId, aContact, aData) {
		var p = this.RESTClient.newRESTClientParameters();
		p.add("sid", this._token.session_id);
		p.add("bookId", aBookId);
		p.add("contact", JSObjContactShell(aContact));
		// closure
		var self = this;
		this.RESTClient.invoke(this._url, "createContactInBook", p, true, function(name, obj, xml, data) {self._callback(name, obj, xml, data);}, aData);
	},
	modifyContact: function(aBook, aContact, aData) {
    this.logger.debug("modifyContact()", false, false);
		var p = this.RESTClient.newRESTClientParameters();
		p.add("sid", this._token.session_id);
		p.add("book", getBookName(aBook));
		p.add("contact", JSObjContactShell(aContact));
		// closure
		var self = this;
		this.RESTClient.invoke(this._url, "modifyContact", p, true, function(name, obj, xml, data) {self._callback(name, obj, xml, data);}, aData);
	},
	removeContact: function(aBook, aUid, aData) {
    this.logger.debug("removeContact()", false, false);
		var p = this.RESTClient.newRESTClientParameters();
		p.add("sid", this._token.session_id);
		p.add("book", getBookName(aBook));
		p.add("id", aUid);
		// closure
		var self = this;
		this.RESTClient.invoke(this._url, "removeContact", p, true, function(name, obj, xml, data) {self._callback(name, obj, xml, data);}, aData);
	},
	unsubscribeBook: function(aBookId, aData) {
		var p = this.RESTClient.newRESTClientParameters();
		p.add("sid", this._token.session_id);
		p.add("bookId", aBookId);
		// closure
		var self = this;
		this.RESTClient.invoke(this._url, "unsubscribeBook", p, true, function(name, obj, xml, data) {self._callback(name, obj, xml, data);}, aData);
	},
	listBooks: function(aData) {
		throw Cr.NS_ERROR_NOT_IMPLEMENTED;
	},
	getContactFromId: function(aBook, aUid, aData) {
    this.logger.debug("getContactFromId()", false, false);
		var p = this.RESTClient.newRESTClientParameters();
		p.add("sid", this._token.session_id);
		p.add("book", getBookName(aBook));
		p.add("id", aUid);
		// closure
		var self = this;
		this.RESTClient.invoke(this._url, "getContactFromId", p, true, function(name, obj, xml, data) {self._callback(name, obj, xml, data);}, aData);
	},
	getContactTwinKeys: function (aBook, aContact, aData) {
		throw Cr.NS_ERROR_NOT_IMPLEMENTED;
	},
	doLogin: function(aLogin, aPwd, aOrigin, aData) {
    this.logger.debug("doLogin()", false, false);
		var p = this.RESTClient.newRESTClientParameters();
		p.add("login", aLogin);
		p.add("password", aPwd);
		p.add("origin", aOrigin);
		// closure
		var self = this;
		this.RESTClient.invoke(this._loginUrl, "doLogin", p, true, function(name, obj, xml, data) {self._callback(name, obj, xml, data);}, aData);
	},
	isReadOnly: function(aBook, aData) {
		throw Cr.NS_ERROR_NOT_IMPLEMENTED;
	}
};

function AddressBookShell(aXml) {
	this._mXml = aXml;
}

AddressBookShell.prototype = {
	QueryInterface: function(aIID) {
		if (!aIID.equals(Ci.nsISupports) &&
			!aIID.equals(Ci.obmIRAddressBook)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},
	get uid() {return _xL(this._mXml.@uid)},
	get	name() {return _xS(this._mXml.*::name)},
	get	ownerDisplayName() {return _xS(this._mXml.*::ownerDisplayName)},
}

function ContactShell(aXml) {
	this._mXml = aXml;
	
	this._mPhones = [];
	for each (var phone in aXml.*::phones.*) {
		var type = _obmTypesMappings[_xS(phone.@label).replace("PREF;","")];
		if (type)
			this._mPhones[type] = _xS(phone.@number);
	}
	
	this._mEmails = [];
	for each (var mail in aXml.*::emails.*) {	
		var type = _obmTypesMappings[_xS(mail.@label).replace("PREF;","")];
		if (type)
			this._mEmails[type] = _xS(mail.@value);
	}
	
	this._mWebSites = [];
	for each (var site in aXml.*::websites.*) {
		var type = _obmTypesMappings[_xS(site.@label).replace("PREF;","")];
		if (type)
		this._mWebSites[type] = _xS(site.@url);
	}
	
	this._mAddresses = [];
	for each (var address in aXml.*::addresses.*) {
		var type = _obmTypesMappings[_xS(address.@label).replace("PREF;","")];
		if (type) {
			this._mAddresses[type] = {};
			this._mAddresses[type].street = _xS(address);
			this._mAddresses[type].state = _xS(address.@state);
			this._mAddresses[type].city = _xS(address.@town);
			this._mAddresses[type].country = _xS(address.@country);
			this._mAddresses[type].zipCode = _xS(address.@zip);
			this._mAddresses[type].expressPostal = _xS(address.@expressPostal);
		}
	}

}

ContactShell.prototype = {
	QueryInterface: function(aIID) {
		if (!aIID.equals(Ci.nsISupports) &&
			!aIID.equals(Ci.obmIRContact)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},
	get uid() {return _xS(this._mXml.@uid)},
	get	addressbookid() {return _xL(this._mXml.*::addressbookid)},
	get	firstName() {return _xS(this._mXml.*::first)},
	get	lastName() {return _xS(this._mXml.*::last)},
	get	aka() {return _xS(this._mXml.*::aka)},
	get	email() {return _sF(this._mEmails["email"])},
	get	email2() {return _sF(this._mEmails["email2"])},
	get	workPhone() {return _sF(this._mPhones["workPhone"])},
	get	homePhone() {return _sF(this._mPhones["homePhone"])},
	get	workFax() {return _sF(this._mPhones["workFax"])},
	get pagerPhone() {return _sF(this._mPhones["pagerPhone"])},
	get	mobilePhone() {return _sF(this._mPhones["mobilePhone"])},
	get	homeStreet() {return ((this._mAddresses["home"]) ? this._mAddresses["home"].street : null)},
	get	homeZipCode() {return ((this._mAddresses["home"]) ? this._mAddresses["home"].zipCode : null)},
	get	homeCity() {return ((this._mAddresses["home"]) ? this._mAddresses["home"].city : null)},
	get	homeState() {return ((this._mAddresses["home"]) ? this._mAddresses["home"].state : null)},
	get	homeExpressPostal() {return ((this._mAddresses["home"]) ? this._mAddresses["home"].expressPostal : null)},
	get	homeCountry() {return ((this._mAddresses["home"]) ? this._mAddresses["home"].country : null)},
	get homeWebPage() {return _sF(this._mWebSites["homeWebPage"])},
	get	title() {return _xS(this._mXml.*::title)},
	get	service() {return _xS(this._mXml.*::service)},
	get	company() {return _xS(this._mXml.*::company)},
	get	workStreet() {return ((this._mAddresses["work"]) ? this._mAddresses["work"].street : null)},
	get	workZipCode() {return ((this._mAddresses["work"]) ? this._mAddresses["work"].zipCode : null)},
	get	workCity() {return ((this._mAddresses["work"]) ? this._mAddresses["work"].city : null)},
	get	workState() {return ((this._mAddresses["work"]) ? this._mAddresses["work"].state : null)},
	get	workExpressPostal() {return ((this._mAddresses["work"]) ? this._mAddresses["work"].expressPostal :null)},
	get	workCountry() {return ((this._mAddresses["work"]) ? this._mAddresses["work"].country : null)},
	get workWebPage() {return _sF(this._mWebSites["workWebPage"])},
	get	comment() {return _xS(this._mXml.*::comment)},
	get caluri()  {return _xS(this._mXml.*::caluri)},
};

function AddressBookChangesResponseShell(aXml) {
	this._updated = [];
	this._removed = [];
	this._updatedAB = [];
	this._removedAB = [];
	this._lastSync = aXml.@lastSync.toString(); 

	for each (var updatedAB in aXml.*::addressbooks.*::updated.*) {
		this._updatedAB.push(new AddressBookShell(updatedAB));
	}

	for each (var removedAB in aXml.*::addressbooks.*::removed.*) {
		this._removedAB.push(removedAB.@uid.toString());
	}

	for each (var updated in aXml.*::contacts.*::updated.*) {
		this._updated.push(new ContactShell(updated));
	}
	
	for each (var removed in aXml.*::contacts.*::removed.*) {
		this._removed.push(removed.@uid.toString());
	}
}

AddressBookChangesResponseShell.prototype = {
	QueryInterface: function(aIID) {
		if (!aIID.equals(Ci.nsISupports) &&
			!aIID.equals(Ci.obmIRAddressBookChangesResponse)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},
	getUpdatedAddressBooks: function(count) {
		count.value = this._updatedAB.length;
		return this._updatedAB;
	},
	getRemovedAddressBooksIds: function(count) {
		count.value = this._removedAB.length;
		return this._removedAB;
	},
	getUpdatedContacts: function(count) {
		count.value = this._updated.length;
		return this._updated;
	},
	getRemovedContactIds: function(count) {
		count.value = this._removed.length;
		return this._removed;
	},
	get lastsync() {
		return this._lastSync;
	}
};

function GetSyncContactResponseShell(aXml) {
	this._updated = [];
	this._removed = [];
	this._lastSync = aXml.@lastSync.toString(); 

	for each (var updated in aXml.*::updated.*) {
		this._updated.push(new ContactShell(updated));
	}
	
	for each (var removed in aXml.*::removed.*) {
		this._removed.push(removed.@uid.toString());
	}
}

GetSyncContactResponseShell.prototype = {
	QueryInterface: function(aIID) {
		if (!aIID.equals(Ci.nsISupports) &&
			!aIID.equals(Ci.obmIRAddressBookSyncResponse)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},
	getUpdatedContacts: function(count) {
		count.value = this._updated.length;
		return this._updated;
	},
	getRemovedContactIds: function(count) {
		count.value = this._removed.length;
		return this._removed;
	},
	get lastsync() {
		return this._lastSync;
	}
};


// module

var ObmRAddressBookProxyModule = {
	mCID: Components.ID("{4b4d13f2-53c0-439a-85c9-f9ac654f72c7}"),
	mContractID: "@obm.org/obm-sync-rest/addressbookproxy;1",
	registerSelf: function (compMgr, fileSpec, location, type) {
		compMgr = compMgr.QueryInterface(Ci.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(
			this.mCID,
			"OBM Address Book Proxy",
			this.mContractID,
			fileSpec,
			location,
			type
		);
	},
	getClassObject: function (compMgr, cid, iid) {
		if (!cid.equals(this.mCID)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		if (!iid.equals(Ci.nsIFactory)) {
			throw Cr.NS_ERROR_NOT_IMPLEMENTED;
		}
		return this.mFactory;
	},
	mFactory: {
		createInstance: function (outer, iid) {
			if (outer != null) {
				throw Cr.NS_ERROR_NO_AGGREGATION;
			}
			return (new ObmRAddressBookProxy()).QueryInterface(iid);
		}
	},

	canUnload: function(compMgr) {
		return true;
	}
};

function NSGetModule(compMgr, fileSpec) {
	return ObmRAddressBookProxyModule;
}

