/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
/* AddressBook Contact Synchronizer */

var scriptLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
                             .createInstance(Components.interfaces.mozIJSSubScriptLoader);

if ( typeof(Base_Synchronizer) == "undefined" ) {
  scriptLoader.loadSubScript("chrome://obm-extension/content/calendar/synchronizer/Base_Synchronizer.js");
}

if ( typeof(UtilsOBM) == "undefined" ) {
  scriptLoader.loadSubScript("chrome://obm-extension/content/calendars/UtilsOBM.js");
}

function AddressBook_Contact_Synchronizer() {
    this.mSupportedContainerType = Components.interfaces.nsIAbDirectory;
    this.mSupportedItemType = Components.interfaces.nsIAbCard;
}

AddressBook_Contact_Synchronizer.prototype = {

  __proto__: new Base_Synchronizer(),
  // TODO. OBM_NEW_AD_MANAGER. use obmIAddressBooksManager 
  getContainerOBMName: function(aContainer /* nsIAbDirectory */) {
      if (this.abVersion != 3) {
		var matches = aContainer.QueryInterface(Components.interfaces.nsIRDFResource).Value.split('/').pop().match(/.*alia-obm-(.*)\.mab/);
		return matches ? matches.pop() : null;
	  } else {
		var names = UtilsOBM.getCharPref("extensions.obm.addressbooks", null);
		names = names ? names.split(",") : [];
		for each(var obmName in names) {
		  var dirPrefId = "ldap_2.servers." + obmName;//UtilsOBM.getCharPref("extensions.obm.addressbooks."+obmName, null);
		  if (dirPrefId == aContainer.dirPrefId) {
			return obmName;
		  }
		}
		return null;
	  }
  },

  getItemID: function(aItem) {
      if (this.abVersion != 3) {
		return aItem.anniversaryDay;
	  } else {
		try {
		  return aItem.getProperty("ObmId", null);
		} catch(e) {
		  return null;
		}
	  }
  },

  setItemID: function(aContainer, aItem, aNewID) {
      if (this.abVersion != 3) {
		var addrDb = this._getAddressBookDatabase(aContainer);
		addrDb.setCardValue(aItem, "AnniversaryDay", aNewID, false /* notify */);
		addrDb.commit(Components.interfaces.nsAddrDBCommitType.kSessionCommit);
	  } else {
		aItem.setProperty("ObmId", aNewID);
		aContainer.modifyCard(aItem);
	  }
  },

  /* SYNCHRONIZER SPECIFIC FUNCTIONS */

  _getAddressBookDatabase: function(aDirectory /* nsIAbDirectory */) {
      var addressBookService = Components.classes["@mozilla.org/addressbook;1"]
                                         .getService(Components.interfaces.nsIAddressBook);
      return addressBookService.getAbDatabaseFromURI(aDirectory.QueryInterface(Components.interfaces.nsIRDFResource).Value);
  }
};

